﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence;
using Telerik.Windows.Persistence.Services;
using Telerik.Windows.Persistence.Storage;

namespace PersistenceManager_SaveGridView
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private string File_Name;

		IsolatedStorageProvider provider;
		string savedUI;
		public MainWindow()
		{
			File_Name = Environment.CurrentDirectory.Replace("bin\\Debug", "") + "SavedUI.xml";

			InitializeComponent();
			ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
			this.provider = new IsolatedStorageProvider();
			this.DataContext = new MainViewModel();
		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			PersistenceManager manager = new PersistenceManager();
			var stream = manager.Save(this.RadGridView1);

			stream.Position = 0;
			StreamReader sr = new StreamReader(stream);
			string rawXml = sr.ReadToEnd();
			this.savedUI = rawXml;

			using (FileStream fileStream = new FileStream(File_Name, FileMode.Open, FileAccess.ReadWrite))
			{
				StreamWriter streamWriter = new StreamWriter(fileStream);
				streamWriter.Write(rawXml);
				streamWriter.Close();
				fileStream.Close();
			}


			//// Make the XML more readable by replacing the "&lt;" with "<"  and &gt;" with ">".
			var abitMoreReadableXML = rawXml.Replace("&lt;", "<").Replace("&gt;", ">");
		}

		private void RadButton_Click_1(object sender, RoutedEventArgs e)
		{
			PersistenceManager manager = new PersistenceManager();
			//var stream = new MemoryStream();


			string savedData = string.Empty;
			using (var streamReader = new StreamReader(File_Name))
			{
				savedData = streamReader.ReadToEnd();
			}


			var stream = new MemoryStream();
			var writer = new StreamWriter(stream);
			writer.Write(savedData);
			writer.Flush();
			stream.Position = 0;
			manager.Load(stream);
		}
	}
}
